unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FtpEngine, ComCtrls;

type
  TForm1 = class(TForm)
    CustomFtpEngine1: TCustomFtpEngine;
    Edit1: TEdit;
    Edit2: TEdit;
    Addr: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit3: TEdit;
    Edit4: TEdit;
    Button1: TButton;
    Memo1: TMemo;
    Memo2: TMemo;
    StatusBar1: TStatusBar;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    procedure Button1Click(Sender: TObject);
    procedure CustomFtpEngine1Raw(Sender: TCustomFtpEngine;
      const Raw: String);
    procedure CustomFtpEngine1Error(Sender: TCustomFtpEngine;
      const Error: String);
    procedure CustomFtpEngine1InvalidCommand(Sender: TCustomFtpEngine;
      const Raw: String);
    procedure CustomFtpEngine1Notice(Sender: TCustomFtpEngine;
      const Msg: String);
    procedure CustomFtpEngine1CacheHit(Sender: TCustomFtpEngine;
      const Path: String);
    procedure CustomFtpEngine1Login(Sender: TCustomFtpEngine;
      Successful: Boolean; const Msg: String);
    procedure CustomFtpEngine1Connected(Sender: TCustomFtpEngine);
    procedure CustomFtpEngine1Disconnected(Sender: TCustomFtpEngine);
    procedure CustomFtpEngine1DirectoryListing(Sender: TCustomFtpEngine;
      Dir: PDirectoryRecord);
    procedure CustomFtpEngine1TransferData(Sender: TCustomFtpEngine;
      BytesTransfered, FilePosition, TotalFileSize: Integer;
      DataSocketOpenTick: Cardinal);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
    CustomFtpEngine1.Disconnect;

    CustomFtpEngine1.Address := Edit1.Text;
    CustomFtpEngine1.Port := StrToInt(Edit2.Text);
    CustomFtpEngine1.UserName := Edit3.Text;
    CustomFtpEngine1.Password := Edit4.Text;

    CustomFtpEngine1.Connect;
    StatusBar1.Panels.Items[0].Text := 'Connecting...';
end;

procedure TForm1.CustomFtpEngine1Raw(Sender: TCustomFtpEngine; const Raw: String);
begin
    Memo2.Lines.Add(Format('[RAW] %s', [Raw]));
end;

procedure TForm1.CustomFtpEngine1Error(Sender: TCustomFtpEngine;
  const Error: String);
begin
    Memo2.Lines.Add(Format('[ERROR] %s', [Error]));
end;

procedure TForm1.CustomFtpEngine1InvalidCommand(Sender: TCustomFtpEngine; const Raw: String);
begin
    Memo2.Lines.Add(Format('[INVALID COMMAND] %s', [Raw]));
end;

procedure TForm1.CustomFtpEngine1Notice(Sender: TCustomFtpEngine; const Msg: String);
begin
    Memo2.Lines.Add(Format('[NOTICE] %s', [Msg]));
end;

procedure TForm1.CustomFtpEngine1CacheHit(Sender: TCustomFtpEngine; const Path: String);
begin
    Memo2.Lines.Add(Format('[CACHE HIT] "%s"', [Path]));
end;

procedure TForm1.CustomFtpEngine1Login(Sender: TCustomFtpEngine;
  Successful: Boolean; const Msg: String);
begin
    If Successful Then
        Memo2.Lines.Add('[LOGIN] successful')
    Else
        Memo2.Lines.Add('[LOGIN] failed');
end;

procedure TForm1.CustomFtpEngine1Connected(Sender: TCustomFtpEngine);
begin
    Memo2.Lines.Add('--CONNECTED--');
    StatusBar1.Panels.Items[0].Text := 'Connected';
end;

procedure TForm1.CustomFtpEngine1Disconnected(Sender: TCustomFtpEngine);
begin
    Memo2.Lines.Add('--DISCONNECTED--');
    StatusBar1.Panels.Items[0].Text := 'Disconnected';
end;

procedure TForm1.CustomFtpEngine1DirectoryListing(Sender: TCustomFtpEngine; Dir: PDirectoryRecord);
Var
    i       : Integer;
    PFile   : PFileRecord;
begin
    Memo1.Clear;

    // Add Directories
    For i := 0 To Dir.Dirs.Count-1 Do
        Begin
        PFile := Dir.Dirs.Items[i];
        Memo1.Lines.Add('[' + PFile.Name + ']');
        End;

    // Add Files
    For i := 0 To Dir.Files.Count-1 Do
        Begin
        PFile := Dir.Files.Items[i];
        Memo1.Lines.Add(PFile.Name);
        End;
end;

procedure TForm1.CustomFtpEngine1TransferData(Sender: TCustomFtpEngine;
  BytesTransfered, FilePosition, TotalFileSize: Integer;
  DataSocketOpenTick: Cardinal);
Var
    Ticks   : Cardinal;
    Kbps    : Integer;
begin
    Ticks := GetTickCount-DataSocketOpenTick;
    Kbps := Round(Ticks / 1000);
    If Kbps > 0 Then
        Kbps := Round(BytesTransfered / Kbps)
    Else
        Kbps := BytesTransfered;
    StatusBar1.Panels.Items[1].Text := Format('%d bytes/s   %d/%d', [Kbps, BytesTransfered, TotalFileSize]);
end;

procedure TForm1.Button2Click(Sender: TObject);
Var
    S   : String;
begin
    S := InputBox('Change directory (Relative)', 'New Dir', '');

    // Change To S, Relative To Current Path, Use Cache If Avaliable
    If (S <> '') Then
        CustomFtpEngine1.ChangeDirectory(S, True, False);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
    // Change To Parent Dir, Use Cache If Avaliable
    CustomFtpEngine1.ChangeToParentDirectory(False);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
    // Forces A Directory Refresh
    CustomFtpEngine1.RefreshDirectory;
end;

procedure TForm1.Button5Click(Sender: TObject);
Var
    LocName : String;
    RemName : String;
begin
    LocName := Trim(InputBox('Upload', 'Local File To Upload', ''));
    If (LocName = '') Then Exit;
    RemName := Trim(ExtractFileName(LocName));
    If (RemName = '') Then Exit;
    CustomFtpEngine1.Upload(LocName, RemName, True);
end;

procedure TForm1.Button6Click(Sender: TObject);
Var
    LocName : String;
    RemName : String;
begin
    RemName := Trim(InputBox('Download', 'Remote File To Download', ''));
    If (RemName = '') Then Exit;
    LocName := ExtractFilePath(Application.ExeName) + RemName;
    If (LocName = '') Then Exit;
    CustomFtpEngine1.Download(LocName, RemName, True);
end;

end.
